# -*- coding: iso-8859-15 -*-

################################
# TP 4 : Listes (fin) et Piles #
################################

#-------------------------
# Structure Liste chainee
#-------------------------

class Noeud:
    def __init__(self,val,suiv=None):
        #Par dfaut le pointeur 'suiv' vaut 'None'
        self.val=val # Valeur du noeud
        self.suiv=suiv # Pointeur vers le noeud suivant

class Liste:
    def __init__(self,premier=None):
        # Par defaut la liste est vide 
        self.premier=premier

def affiche_liste(l):
    print("(",end="")
    courant=l.premier
    while courant!=None:
        print(" ",end="")
        print(courant.val,end="")
        courant=courant.suiv
    print(" )")
     
# La liste 2,5,8,3,2,4
liste=Liste(Noeud(2,Noeud(5,Noeud(8,Noeud(3,Noeud(2,Noeud(4)))))))

#*************
# Exercice 1 *
#*************

# Ecrire les procedures suivantes

# 1. insere_apres(l,v,w) qui insere un noeud portant la valeur w apres la
#    premiere occurence de la valeur v dans la liste l. Ne fait rien si
#    v n'est pas prsent dans l.

def insere_apres(l,v,w):
    courant=l.premier
    while courant!=None:
        if courant.val==v:
            n=Noeud(w)
            n.suiv=courant.suiv
            courant.suiv=n
            return
        courant=courant.suiv
    
# 2. insere_avant(l,v,w) qui insere un noeud portant la valeur w avant la
#    premiere occurence de la valeur v dans la liste l. Ne fait rien si
#    v n'est pas prsent dans l.

def insere_avant(l,v,w):
    courant=l.premier
    if courant==None:
        return
    if courant.val==v:
        n=Noeud(w)
        n.suiv=premier
        l.premier=n
        return
    while courant.suiv!=None:
        if courant.suiv.val==v:
            n=Noeud(w)
            n.suiv=courant.suiv
            courant.suiv=n
            return
        courant=courant.suiv
        
#----------------
# Structure Pile
#----------------

# Une pile est un conteneur possedant 4 oprations
# push(x) permettant d'ajouter la valeur x en haut de la pile
# top() retournant la valeur du haut de la pile
# pop() retirant la valeur du haut de la pile
# empty() testant si la pile est vide ou pas

class Pile:
    def __init__(self):
        self.data=[]
        
    def push(self,x):
        self.data.append(x)
    
    def top(self):
        return self.data[-1]
        
    def pop(self):
        self.data.pop()
        
    def empty(self):
        return len(self.data)==0

#************
# Exercice 2
#************

# A l'aide d'une pile, ecrire une fonction inverse(l) qui retourne
# la liste obtenue en inversant la liste l

def inverse(l):
    # Si la liste est vide, on retourne une liste vide
    if l.premier==None:
        return Liste()
    p=Pile()
    courant=l.premier
    # On empile les valeurs de l sur p
    while courant!=None:
        p.push(courant.val)
        courant=courant.suiv
    # On cre la liste inv
    inv=Liste()
    inv.premier=Noeud(p.top())
    p.pop()
    courant=inv.premier
    while not p.empty():
        n=Noeud(p.top())
        p.pop()
        courant.suiv=n
        courant=n
    return inv

#**************
#* Exercice 3 *
#**************

# La notation polonaise inverse (ou notation post-fixe) permet d'crire de
# facon non ambigue les formules arithmtiques sans utiliser de parenthses.
# Le principe est qu'un oprateur binaire (+,-,*) soit crit aprs ses arguments.
# L'opration 3+5 s'crit donc "3 5 +"
# Le but de cet exerecice est de crer une calculatrice utilsant la notation
# polonaise inverse.

# 1. Reprsenter le calcul ((6+5)*9-8)+3 en notation polonaise

# 2. Evaluer a la main les expressions suivantes

calc1=["1","2","+","4","*","3","+"]
calc2=["3","4","1","2","+","*","+"]
calc3=["5","6","+","2","3","*","-"]
calc4=["7","4","3","+","2","*","-"]

# 3. Pour simplifier on supposera que les nombres n'auront qu'un seul chiffre
#    (0,1,...,9) et que les oprateurs seront seulement '-','+','*'.
#    A l'aide des fonctions est_chiffre(c) et chiffre(c) suivante et d'une pile 
#    crire une fonction  fonction eval(calc) prenant en entre un calcul comme
#    calc 1 et retourant le rsultat

def est_chiffre(c):
    return '0'<=c[0] and c[0]<='9'

def chiffre(c):
    return int(c[0])-int('0')

def evalue(calc):
    p=Pile()
    for i in range(len(calc)):
        c=calc[i]
        if est_chiffre(c):
            p.push(chiffre(c))
        else:
            b=p.top()
            p.pop()
            a=p.top()
            p.pop()
            if c=='+':
                p.push(a+b)
            elif c=='*':
                p.push(a*b)
            elif c=='-':
                p.push(a-b)
            else:
                print("Oprateur non gr")
                return
    return p.top()
            
#************
# Exercice 4 
#************

# Le but de cet exercice est de rsoudre le jeu des tours de Hano
# Voici une structure reprsentant ce jeu  l'aide de pile

class ToursHanoi:
    def __init__(self,n):
        # n est le nombre de disque
        # on a 3 tours numrotes 0,1 et 2
        self.n=n
        self.pile=[Pile(),Pile(),Pile()]
        for i in range(0,n):
            self.pile[0].push(n-i-1)

    def deplace(self,s,a):
        #Deplace un disque de la tour s vers la tour a
        if self.pile[s].empty():
            print("Impossible de dplacer un dique de la tour",s,"car elle est vide !")
            return
        vs=self.pile[s].top()
        if not self.pile[a].empty():
            va=self.pile[a].top()
            if vs>va:
                print("Impossibe de dplacer le disque de la tour",s,"vers la tour",a,"car elle contient un disque plus grand !")
                return
        self.pile[s].pop()
        self.pile[a].push(vs)

    def fini(self):
        return len(self.pile[2])==n

    def affiche(self):
        print()
        print(' '*self.n+'0'+' '*(2*self.n+1)+'1'+' '*(2*self.n+1)+'2')
        print(' '*self.n+'|'+' '*(2*self.n+1)+'|'+' '*(2*self.n+1)+'|')
        for i in range(0,self.n):
            for j in range(3):
                if len(self.pile[j].data)>=self.n-i:
                    v=self.pile[j].data[self.n-i-1]
                    print(' '*(self.n-v)+'x'*(2*v+1)+ ' '*(self.n-v+1),end='')
                else:
                    print(' '*(self.n)+'|'+' '*(self.n+1),end='')
            print()

if __name__=="__main__":
    tours=ToursHanoi(5)
    tours.affiche()
    tours.deplace(0,2)
    tours.affiche()
    tours.deplace(0,2)
    tours.affiche()
